// **** BEGIN LICENSE BLOCK ****
//   Copyright(c) 2009-2010 MATSUZAWA Jiro
//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA
//   02110-1301, USA.  */
// **** END LICENSE BLOCK ****

var rencon;
if (!rencon) {
    rencon = {};
} else if (typeof rencon != "object") {
    throw new Error("");
}

rencon.FileManager = function(){}

rencon.FileManager.
genOutFileName = function()
{
    var d       = new Date();
    var year    = d.getFullYear();
    var month   = d.getMonth() + 1;
    var date    = d.getDate();
    var hour    = d.getHours();
    var minute  = d.getMinutes();
    var second  = d.getSeconds();
    var suffix  = rencon.FileManager._getSuffix();

    if (month < 10) {
        month = "0" + month.toString();
    }
    if (date < 10) {
        date = "0" + date.toString();
    }
    if (hour < 10) {
        hour = "0" + hour.toString();
    }
    if (minute < 10) {
        minute = "0" + minute.toString();
    }
    if (second < 10) {
        second = "0" + second.toString();
    }

    // add vain string for preventing calcuration by numeric
    return year + ""  +month + date + "_" + hour + minute + second + suffix;
}

rencon.FileManager.
pickOutFileName = function()
{
    var e;
    var picker = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
    picker.init(window, "output", picker.modeSave);
//    picker.defaultExtension = ".txt";
//    picker.appendFilters(picker.filterText);
//    picker.appendFilters(picker.filterAll);
    var rtn = picker.show();
    if (rtn == 1) {
        e = new Error("file is not selected. stop");
        e.type = "unSelected";
        throw e;
    } else if (rtn == 2) {
        // check file is writable if file exists
        if (!picker.file.isWritable()) {
            e =  new Error(picker.file.path);
            e.type = "fileUnWritable";
            throw e;
        }
    }
    if (!picker.file.parent.isWritable()) {
        e =  new Error(picker.file.parent.path);
        e.type = "dirUnWritable";
        throw e;
    }
    return picker.file.path;
}


//rencon.FileManager.
//_getPath = function()
//{
//    return rencon.System.homeDir() + rencon.System.pathDelimiter() + "rencon";
//}

rencon.FileManager.
_getSuffix = function()
{
    return ".txt";
}
